#ifndef _CAMERA_H_
#define _CAMERA_H_
#include <vector>
#include <cstdio>
#include <cmath>
#include "vector3d.h"
// obsolute
//const int NORMAL=0; // same number of cameraset.camType index
//const int XY=1;
//const int YZ=2;
//const int XZ=3;

// new definition
// note! POV-Ray use left hand system.
// So,this definition also use left hand system.
// But,OpenGL use right hand system.
const int PERSPECTIVE=0; // Perspective
const int XYMP=1; // XY Ortho : Z - > +
const int XYPM=2; // XY Ortho : Z + > -
const int YZMP=3; // YZ Ortho : X - > +
const int YZPM=4; // YZ Ortho : X + > -
const int XZMP=5; // XZ Ortho : Y - > +
const int XZPM=6; // XZ Ortho : Y + > -

class Camera {
public:
  Camera();
  Camera(const Camera&);
  ~Camera();
  const Camera& operator=(const Camera&);
  void WriteFile(FILE*);
  void ReadFile(FILE*);
 
  int type;
  char name[255];
  Vector3d view,camera; // view : only for perspective 
  int width,height;
  float eyeAngle;
  float zoom; // only for ortho
};

#endif // _CAMERA_H_
