#ifndef _EDGE_H_
#define _EDGE_H_
 
#include <cstdio>
#include <vector>
#include "pygmalion.h"

class Vertex;
class Edge;
class Face;

extern vector<Vertex> vertex; // Vertex Vector
extern vector<Edge> edge; // Edge Vector
extern vector<Face> face; // Face Vector

const int Left=0; // element[0]
const int Right=1; // element[1]

extern const int sNORMAL;
extern const int sSUBDIVIDE;
extern int nowStatus;


class Edge{
public:
  Edge();
  Edge(const int,const int);
  Edge(const Edge&);
  ~Edge();
  const Edge& operator=(const Edge&);
  
  //Vector3d GetMid();
  const Vertex& ReturnVertex(const int); // Why I made this procedure?
  Vertex CalcEdgePoint();
  const Vertex& ReturnEdgePoint(); // This should be called after CalcEdgePoint
  void ConnectToFacePoint(); // This should be called after Face
  void SetFaceLink();
  void UnSetFaceLink(int);
  int FindAddFace();
  void Print();
  void Info();
  void Draw();
  void MoreSharp();
  void MoreSmooth();
  void WriteFile(FILE*);
  void ReadFile(FILE*);
  int AnotherVertex(int);
  int AnotherFace(int); // This procedure should be called in edge subjecting to two faces !!

  vector<int> vertexLink;
  vector<int> facePLink; // int number specify face number
  
  int edgePointLink; // order of calculated Edge Point
  float weight;
private:
};

#endif // _EDGE_H_
