#ifndef _FACE_H_
#define _FACE_H_

#include <vector>

class Vertex;
class Edge;

class Face{
public:
  Face();
  Face(const int,const int,const int,const int,const int,const int); // three vertices Face
  Face(const int,const int,const int,const int,
       const int,const int,const int,const int); // four vertices Face
  Face(const Face&);
  ~Face();
  const Face& operator=(const Face&);
  Vertex CalcFacePoint();
  const Vertex& ReturnFacePoint();
  void Print();
  void Info();
  const Vector3d Normal(); // temporary
  const Vector3d Normal(int); // specify vertex
  void Draw();
  void WriteFile(FILE*);
  void ReadFile(FILE*);
  int HaveEdge(int);
  int OppositeVertex(int);
  int HasBreak(int);
  int FindEdge(int,int);
  void ReverseNormal();

  // The name "layer" may be wrong usage. The "texture" perhaps be right.
  int layer; 
  
  vector<int> edgeLink; // specify edge number
  vector<int> vertexLink; // 3 or 4 vertices number
  int facePointLink; // order of calculated Face Point
private:
};

#endif // _FACE_H_
