#ifndef _PYGMALION_H_
#define _PYGMALION_H_
#include <vector>

class Fl_Menu_Item;
class Vector3d;
class Camera; 


// POV-Ray export type
const int TRIANGLE=0;
const int SMOOTH_TRIANGLE=1;
const int TEMP_EXPORT=2; // actually SMOOTH_TRIANGLE and render 

// function Load type {open,import}
const int OPEN=0;
const int IMPORT=1;

const double defOGLAngle=46.826450; // 60 POVAngle in 4:3 win

// right,left,top,bottom
// setting for Windows98,qvwm default
// TODO for window manager
const int glOffsetR=6;
const int glOffsetL=6; 
const int glOffsetT=25;
const int glOffsetB=6; 

// AddViewIndex offset
const int deleteIndexOffset=6;
const int toggleIndexOffset=4;

static const char * const tmpExpFilename = "tmppygzz.pov";


// weight
void SelectedSmooth();
void SelectedSharp();
void WeightPropagate();

// debug 
void DebugObjects();
void PrintHelp();
void PrintVertex();
void PrintEdge();
void PrintFace();
void PrintVec(vector<int>);

// basic
int FindEdge(const int,const int);
void Unique(vector<int>&);


// modify
void AddEdge(int,int);
void AddFace(int,int,int,int,int,int);
void AddFace(int,int,int,int,int,int,int,int);
void RemoveExtraFace();
void RemoveSelected();
void Find4Face(int,int,int);
void Sort3(int&,int&,int&);
void RemoveFace(int);
void RemoveEdge(int);
void RemoveVertex(int);
void Extrude();
void ExtrudeCore();
void FourToThree();

// Select
void SelectAll();
void DeselectAll();
void DeselectAllofAll();
void RefineTotalV();

// Callback
int CheckSave();
void NewCB();
void OpenCB();
void ChangeCB();
void SetChanged(int);
void SaveCB();
void SaveAsCB();
void QuitCB();



void CreateNewWin();
void ChangeWinProp();

void CreateView(int);
void CreateCamera(int);
void CreateGLWUI();
void DeleteView(int);
void PreDeleteView(Fl_Menu_Item*,int);
void AlignViews();
void ToggleView(Fl_Menu_Item*,int);

void CheckBBSCore(Vector3d&);
void CheckBBS(vector<int>&); // check bounding box of Vertex[vector[]]
void CenteringObject();

double POVAng2OGLAng(Camera&,double);
double OGLAng2POVAng(Camera&,double);

int SameDirection(int);
int ArrangeNormal();
void ReverseAllNormal();

#endif // _PYGMALION_H_
