#include <cstring>
#include <iostream>
#include <vector>
#include <FL/fl_ask.H>
#include "camera.h"
#include "pygmalion.h"
#include "fileio.h"
#include "usersetting.h"
#include "render.h"

extern vector<Camera> cameraList;
extern int outputC; // output camera
extern UserSetting* userSetting;

extern char renderExe[512]; // user specify renderer
extern char renderOpt[512]; // user specify render option
extern char typeOpt[512]; // auto specific render option
extern int renderSubTimes; // subdivision times for rendering
extern int pauseCheck;
extern int povType;


/////////////////////////////////////////////////////
// This function are called within Win32 OS
void
TwoSlash(char* str){
  //DebugOut("before : " << str);
  cout << "before : " << str << endl;
  for(int cnt1=0;cnt1<strlen(str)+1;cnt1++){ 
    if(str[cnt1]=='/'){
      for(int cnt2=strlen(str);cnt2>cnt1;cnt2--){
        str[cnt2]=str[cnt2];    
      }
      str[cnt1]='\\';
    }
  }
  //DebugOut("after : " << str);
  cout << "after : " << str << endl;
}

void
Render(){
  char renderScript[1024];
  if(!strcmp(renderExe,"")){
    fl_alert("Renderer not set! Please set renderer.");
    userSetting->show();
    userSetting->renderTab->show();
    userSetting->mainWin->set_modal();
    return;
  }
  if(cameraList.size()==0){
    fl_alert("Camera not found... Please create camera.");
    return;
  }
  
  strcpy(renderScript,"");
#ifdef WIN32
  strcpy(renderScript,"\"");
#endif
  strcat(renderScript,renderExe); // execute renderer
#ifdef WIN32  
  strcat(renderScript,"\"");
  TwoSlash(renderScript);
#endif
  strcat(renderScript," ");
  strcat(renderScript,renderOpt); // render option
  strcat(renderScript," ");
  char tmpWidth[10];
  char tmpHeight[10];
  sprintf(tmpWidth,"+W%d ",cameraList[outputC].width);
  sprintf(tmpHeight,"+H%d ",cameraList[outputC].height);  
  strcat(renderScript,tmpWidth);
  strcat(renderScript,tmpHeight);
#ifndef WIN32
  if(pauseCheck){
    strcat(renderScript,"+P ");
  }
#endif
  if(povType){ // in case : renderer is POV-Ray
#ifdef WIN32
    strcpy(typeOpt,"/RENDER ");
#else
    strcpy(typeOpt,"+D +I");
#endif
  }else{ // other cases :
    strcpy(typeOpt,"");
  }
  strcat(renderScript,typeOpt); // renderer type option
  strcat(renderScript,tmpExpFilename);
#ifndef WIN32
  strcat(renderScript," &");
#endif  

  ExportPOVCore(renderSubTimes,TEMP_EXPORT);
  system(renderScript);
}
