#ifndef _VECTOR3D_H_
#define _VECTOR3D_H_

#include <cstdio>
 
class Vector3d {
public:
  Vector3d();
  Vector3d(const double&,const double&,const double&); // init by 3 doubles
  Vector3d(const Vector3d&);
  ~Vector3d(); // virtual required?
  const Vector3d& operator=(const Vector3d&);
  Vector3d operator+(const Vector3d&);
  Vector3d operator-(const Vector3d&);
  Vector3d operator*(const double&);
  //ostream operator<<(Vector3d&);
  
  void Plus(const Vector3d&);
  void Minus(const Vector3d&);
  void Multi(const double&);
  const Vector3d Cross(const Vector3d&);
  void Cross(const Vector3d&,const Vector3d&);
  const double Dot(const Vector3d&);
  void Normalize();
  void MultiMat33(double*);
  
  void Set(const double&,const double&,const double&);
  void Get(double&,double&,double&);
  double X();
  void X(double);
  double Y();
  void Y(double);
  double Z();
  void Z(double);
  void Print();
  void WriteFile(FILE*);
  
  double coord[3];
  
private:
protected:
  //double coord[3];
  // Because of tiring and bugs(?), turn to public.
};

#endif // VECTOR3D_H_
